
(*

Incorrect Music II

Andreja Andric, May 2011.

Where software becomes an art form, software development 
becomes an art practice. Consequently also code testing 
and code inspection, as activities towards discovering 
errors in code, become likewise part of the artistic 
process, being integral part of software development 
process. This little work is an example of accepting a 
programming error as a constitutive part of the creative 
result. An ommission, a lapse of memory, a misspelling, 
it's disruptive of routine, unpredictable, refreshing, 
and may bring new insights. Its consequences may be 
catastrophic or just funny, but at times it leads us by a 
shortcut to where we wanted to go in the beginning.
In "Incorrect Music 2" a tiny music generator written in 
Pascal contains a programming ommission - it writes to the
resulting file only lower byte of each sample. Each 
resulting sample therefore is formed out of two lower 
bytes of two intended samples. 

Compile this program and run it like this: 
incmus2 > incmus2.wav
to obtain the complete recording

Modify the value of constant LEN below to get longer or
shorter music pieces (255 is maximum otherwise you need
more changes in the code).
LEN=64 corresponds to a 47 seconds long music piece.

Modify the value of constant START_SEED below to get
different variations on the piece.

*)

program IncorrectMusic2;

const LEN=255;
const START_SEED=13;

var 
   i, j, k, upper_limit, lower_limit, 
   current_amplitude:integer;
   step_up, step_down, sign:integer;
   regular:boolean;
   seed, aa, cc:integer;

procedure writeheader;
const 
   header:array[1..44] of integer=(
      82, 73, 70, 70,  44,   0, LEN,  0, 
      87, 65, 86, 69, 102, 109, 116, 32, 
      16,  0,  0,  0,   1,   0,   1,  0, 
      68,172,  0,  0,  16, 177,   2,  0, 
       4,  0, 16,  0, 100,  97, 116, 97, 
       0,  0,LEN,  0
    );
var
   i:integer;
begin
   for i:=1 to 44 do write(chr(header[i]));
end;

function rnd(limit:integer):integer;
begin
   seed:=seed*aa+cc;
   rnd:=(seed+32768) mod limit;
end;

begin
   upper_limit:=32000; 
   lower_limit:=-32000;

   step_up:=17; step_down:=3; sign:=1; k:=0;
   regular:=true; 

   seed:=START_SEED;
   aa:=5377; cc:=13849;

   writeheader;

   for i:=1 to 16384 do
   begin
      for j:=1 to 4*LEN do
      begin
         while k<0 do 
         begin 
            k:=k+step_up;          
            current_amplitude:=current_amplitude+sign 
         end;
         k:=k-step_down;

         write(chr(current_amplitude mod 256));

         (* If going upwards we overstepped the upper 
            limit we start going downwards *)
         if (sign=1) and (current_amplitude>upper_limit)             
            then sign:=-1;

         (* If going downwards, we overstepped the lower 
            limit, we start going upwards *)
         if (sign=-1) and (current_amplitude<lower_limit) 
            then sign:=1;

         (* If our walk isn't supposed to be regular, 
            we change the step up by one or two, however,
            step must never be zero *)
         if not regular then 
         begin
            step_up:=step_up-2+rnd(5);
            if step_up=0 then step_up:=1;
            step_down:=step_down-2+rnd(5);
            if step_down=0 then step_down:=1;
         end;
      end;

      (* Sudden parameter changes at random times *)
      if(rnd(51)=0) then 
      begin 
         step_down:=2+rnd(50); step_up:=2+rnd(50) 
      end;
      if(rnd(211)=0) then sign:=0;
      if(rnd(173)=0) then sign:=1;
      if(rnd(241)=0) then regular:=not regular;
      if(i mod 1000=0) then aa:=aa-77;

   end;
end.

